﻿
using System;
using System.Collections;
using System.Collections.Generic;
using System.Linq;
using UnityEngine;

namespace SharpJunctionAngles
{

    public class ToolReplacer
    {
              
        System.Type oldToolType = null;
        System.Type newToolType = null;
        List<NetTool> replacedInstances = new List<NetTool>();


        public ToolReplacer(System.Type oldToolType, System.Type newToolType)
        {
            this.oldToolType = oldToolType;
            this.newToolType = newToolType;
        }


        public void replaceTool()
        {
            Debug.Log("Replacing tool " + oldToolType.Name + " with " + newToolType.Name + "...");

            //get the tool controller           
            var toolController = GameObject.Find("Tool Controller");
            if (toolController == null)
                return;
                        
            //get the old tool
            var oldTool = toolController.GetComponent(oldToolType.Name) as ToolBase;
            if (oldTool == null)
            {
                Debug.Log("Could not find " + oldToolType.Name + "...");
                return;
            }

            //copyconstruct the new tool and destroy the old tool
            var newTool = toolController.AddComponent(newToolType);
           // Util.copyCommonFieldsByName(oldTool, newTool);
            //GameObject.Destroy(oldTool);
            
            //disguise new tool as old tool (NetToolExt as NetTool)
            string oldToolName = oldTool.tag;
            oldTool.tag = oldTool.tag + "Disabled";
            //newTool.tag = oldToolName;
            newTool.tag = "bla";

        }

        

    }


    //public class NetToolExt : NetTool
    //{
    //    public static ToolReplacer replacer = new ToolReplacer(typeof(NetTool), typeof(NetToolExt));

    //    public new static bool CheckCollidingSegments(ulong[] segmentMask, ulong[] buildingMask, ushort upgrading)
    //    {
    //        Debug.Log("NetToolExt::CheckCollidingSegments()");
    //        return false;
    //    }

    //}


}


